
{

      Demonstracni program pouziti knihovny TPCI1052 s kartou PCI-1052.

                                Verze 1.00

                         (c) 2004, TEDIA spol. s r. o.



   Program demonstruje volani jednotlivych funkci knihovny TPCI1052 pro
   komunikaci s modulem MicroUnit pres kartu PCI-1052. Pro pouziti knihovny
   je nutna znalost modulu MicroUnit v rozsahu jeho Uzivatelske prirucky.
   Knihovnu neni nutno samostatne instalovat, staci ji v ramci instalace
   aplikacniho software pouze prekopirovat do mista, kam bude mit aplikacni
   program nastavenu cestu.
   Knihovna vyuziva low-level driver TEDIA_OX9162.DLL, ktery je soucasti
   dodavky karty a instaluje se automaticky pri zavedeni karty PCI-1052
   do systemu Windows.


  Poznamka:
   Pro jednoduchost a nazornost pouziti je omezeno osetreni chyb, ktere mohou
   za behu programu nastat.
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TPCI1052, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button7: TButton;
    Timer1: TTimer;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Label7: TLabel;
    Panel1: TPanel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Button8: TButton;
    Label14: TLabel;
    Label15: TLabel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;



// deklarace promennych

var
  Form1     : TForm1;      // dialogove okno programu

  HNDL      : DWord;       // handle otevreneho zarizeni PCI-1052

  Verze     : DWord;       // verze knihovny TPCI1052.DLL

                           // konfiguracni data knihovny
  Baud      : DWord;       // komunikacni rychlost modulu MicroUnit, platne
                           // hodnoty : 600, 1200, 2400, 4800, 9600, 19200,
                           // 38400, 57600 a 115200 Bd
  Timeout   : DWord;       // timeout odpovedi modulu, platne hodnoty 1-10000ms
  Opakovani : DWord;       // pocet opakovani volani na modul MicroUnit
                           // v pripade chybne komunikace

  TBuff     : Buff;        // vysilaci buffer, obsahuje data vysilana na modul
                           // MicroUnit (pole DWord)
  RBuff     : Buff;        // prijimaci buffer, obsahuje prijata data z modulu
                           // MicroUnit (pole DWord)
  StatusR   : DWord;       // prijaty Status registr modulu MicroUnit
  StatusP   : DWord;       // status prijmu - komunikace s modulem MicroUnit

  Chyba     : DWord;       // chybovy kod
  TextChyby : Buff;        // slovni vyjadreni chyboveho kodu

  Otevreno  : boolean;     // pomocna promenna signalizujici otevreni knihovny



implementation

{$R *.dfm}

//__________________________________________________ Prepocet hodnoty LongReal _
// Funkce pro prevod prijate zpravy na ciselnou hodnotu. Vstupem jsou prijate
// datove byty odpovedi modulu MicroUnit, vystupem je spocitana real hodnota.

Function PrevodBytesReal(B1,B2,B3,B4:byte) : double;
var
  I,Exp : byte;
  R     : double;
begin
  R:=(B3 and $7F)*1.0;
  R:=(R*256.0+B2)*256.0+B1;
  if B3>127 then R:=-R;
  Exp:=B4 and $7F;
  if Exp>0 then
    for I:=1 to Exp do R:=R/10.0;
  PrevodBytesReal:=R;
end;

//______________________________________________________ Prevod pole na string _
// Funkce pro prevod pole typu Buff na string. Vstupem je text ve forme pole
// bytu, vystupem je text ve forme stringu.

function BuffToStr(B:Buff):string;
var
  S : string;
  I : integer;
begin
  I:=0;
  repeat
    if (B[I]<>0) then S:=S+chr(B[I]);
    inc(I);
  until ((I>99) or (B[I]=0));
  Result:=S;
end;

//______________________________________________________________________________  FormCreate
// Spusteni programu a prednastaveni promennych.

procedure TForm1.FormCreate(Sender: TObject);
begin
  Timer1.Enabled:=false;
  Label9.Caption:='';
  Label11.Caption:='';
  Label13.Caption:='';
  Label15.Caption:='';
  Edit1.Text:='9600';
  Edit2.Text:='15';
  Edit3.Text:='2';
  Edit4.Text:='1';
  Edit5.Text:='200';
  Edit6.Text:='0';
  Edit7.Text:='0';
  Edit8.Text:='0';
  Edit9.Text:='0';
  Edit10.Text:='0';
  Edit11.Text:='0';
  Panel1.Caption:='';
  Panel2.Caption:='';
  Panel3.Caption:='';
  Panel4.Caption:='';
  Button1.Enabled:=true;
  Button2.Enabled:=true;
  Button3.Enabled:=false;
  Button4.Enabled:=false;
  Button5.Enabled:=false;
  Button6.Enabled:=false;
  Button7.Enabled:=false;
  Button8.Enabled:=true;           // systemove promenne

  Otevreno:=false;                 // zarizeni zatim neotevreno
end;
//______________________________________________________________________________  Tl. Version
// Dotaz na verzi knihovny TPCI1052.DLL. Funkci TPCI1052_Version lze volat
// kdykoliv. Parametrem je ukazatel na DWord, ve kterem vraci verzi (nutno
// vydelit 100, tzn. cislo 123 odpovida verzi 1.23).
// Navratova hodnota funkce je 0 v pripade uspesneho provedeni, nenulova
// hodnota signalizuje chybu (toto plati pro vsechny funkce).

procedure TForm1.Button1Click(Sender: TObject);
begin
  Chyba:=TPCI1052_Version(@Verze);
  TPCI1052_Error(Chyba,@TextChyby);
  Label13.Caption:=FloatToStrF(Verze/100,ffFixed,4,2);
  Label15.Caption:=IntToStr(Chyba)+' - '+BuffToStr(TextChyby);
end;
//______________________________________________________________________________  Tl. Init
// Inicializace zarizeni. Funkce TPCI1052_Init se provadi vzdy na zacatku
// cinnosti se zarizenim. Parametrem je ukazatel na DWord, ve kterem funkce
// vraci handle prideleny zarizeni.

procedure TForm1.Button2Click(Sender: TObject);
begin
  Chyba:=TPCI1052_Init(@HNDL);
  TPCI1052_Error(Chyba,@TextChyby);
  Label15.Caption:=IntToStr(Chyba)+' - '+BuffToStr(TextChyby);
  if (Chyba=0) then
    begin
      Otevreno:=true;               // zarizeni otevreno
      Button2.Enabled:=false;
      Button3.Enabled:=true;
      Button4.Enabled:=true;
      Button5.Enabled:=true;
      Button6.Enabled:=true;
      Button7.Enabled:=true;
    end;
end;
//______________________________________________________________________________  Tl. Done
// Uzavreni zarizeni. Funkci TPCI1052_Done se uzavira otevrene zarizeni.
// Parametrem je ukazatel na handle zarizeni (DWord).

procedure TForm1.Button6Click(Sender: TObject);
begin
  Chyba:=TPCI1052_Done(@HNDL);
  TPCI1052_Error(Chyba,@TextChyby);
  Label9.Caption:='';
  Label11.Caption:='';
  Label15.Caption:=IntToStr(Chyba)+' - '+BuffToStr(TextChyby);
  Otevreno:=false;
  Button1.Enabled:=true;
  Button2.Enabled:=true;
  Button3.Enabled:=false;
  Button4.Enabled:=false;
  Button5.Enabled:=false;
  Button6.Enabled:=false;
  Button7.Enabled:=false;
  Button8.Enabled:=true;
end;
//______________________________________________________________________________  Tl. SetConfig
// Zapis konfiguracnich dat knihovny. Pomoci funkce TPCI1052_SetConfig jsou
// do knihovny zapsany konfiguracni data. Parametry jsou handle zarizeni (HNDL),
// komunikacni rychlost (Baud), timeout odpovedi modulu MicroUnit (Timeout) a
// pocet opakovani volani (Opakovani), vse typu DWord.

procedure TForm1.Button3Click(Sender: TObject);
begin
  try
    Baud:=StrToInt(Edit1.Text);
    Timeout:=StrToInt(Edit2.Text);
    Opakovani:=StrToInt(Edit3.Text);
  except
    Label15.Caption:='Chybn zadn parametr';
    Exit;
  end;
  Chyba:=TPCI1052_SetConfig(HNDL,Baud,Timeout,Opakovani);
  TPCI1052_Error(Chyba,@TextChyby);
  Label15.Caption:=IntToStr(Chyba)+' - '+BuffToStr(TextChyby);
end;
//______________________________________________________________________________  Tl. GetConfig
// Cteni konfiguracnich dat knihovny. Pomoci funkce TPCI1052_GetConfig lze
// precist konfiguracni data knihovny. Parametry jsou handle zarizeni (HNDL,
// typ DWord), komunikacni rychlost (Baud, typ ukazatel na DWord), timeout
// odpovedi modulu MicroUnit (Timeout, typ ukazatel na DWord) a pocet opakovani
// volani (Opakovani, typ ukazatel na DWord). Po incializaci knihovny funkci
// TPCI1052_Init jsou konfiguracni parametry prednastaveny na Baud=9600,
// Timeout=10 a Opakovani=2.

procedure TForm1.Button4Click(Sender: TObject);
begin
  Chyba:=TPCI1052_GetConfig(HNDL,@Baud,@Timeout,@Opakovani);
  TPCI1052_Error(Chyba,@TextChyby);
  Edit1.Text:=IntToStr(Baud);
  Edit2.Text:=IntToStr(Timeout);
  Edit3.Text:=IntToStr(Opakovani);
  Label15.Caption:=IntToStr(Chyba)+' - '+BuffToStr(TextChyby);
end;
//______________________________________________________________________________  Tl. Send
// Komunikace s modulem MicroUnit. Po otevreni a pripadnem nastaveni
// konfiguracnich dat probiha komunikace s moduly MicroUnit pomoci funkce
// TPCI1052_Send. Parametry funkce jsou handle zarizeni (HNDL, typ DWord),
// vysilana data do modulu MicroUnit (TBuff, typ ukazatel na pole DWord),
// data prijata z modulu MicroUnit (RBuff, typ ukazatel na pole DWord),
// prijaty Status registr modulu MicroUnit (StatusR, typ ukazatel na DWord)
// a status prijmu jako vysledek komunikace s modulem MicroUnit (StatusP,
// typ ukazatel na DWord).

procedure TForm1.Button5Click(Sender: TObject);
var
  S : string;
  I : integer;
  R : double;
begin
// naplneni vysilaciho bufferu - TBuff[0..7]
  try
    TBuff[0]:=StrToInt(Edit4.Text);      // adresa modulu MicroUnit (0-255)
    TBuff[1]:=StrToInt(Edit5.Text);      // pozadovana funkce AIBus-2
    TBuff[2]:=StrToInt(Edit6.Text);      // periferie modulu MicroUnit
    TBuff[3]:=StrToInt(Edit7.Text);      // prikaz
    TBuff[4]:=StrToInt(Edit8.Text);      // D1
    TBuff[5]:=StrToInt(Edit9.Text);      // D2 data zapisovana do periferie
    TBuff[6]:=StrToInt(Edit10.Text);     // D3
    TBuff[7]:=StrToInt(Edit11.Text);     // D4
  except
    Label15.Caption:='Chybn zadn parametr';
    Exit;
  end;

  Chyba:=TPCI1052_Send(HNDL,@TBuff,@RBuff,@StatusR,@StatusP);

// vyhodnoceni chyby volani funkce TPCI1052_Send
  TPCI1052_Error(Chyba,@TextChyby);
  Label15.Caption:=IntToStr(Chyba)+' - '+BuffToStr(TextChyby);

// vypis prijatych dat z periferie modulu Microunit - RBuff[0..3]
// - ve forme jednotlivych bytu
  S:=''; for I:=0 to 3 do S:=S+IntToStr(RBuff[I])+' ';
  Panel1.Caption:=S;
// - ve forme cisla DWord v hex tvaru
  S:=''; for I:=3 downto 0 do S:=S+IntToHex(RBuff[I],2); S:=S+'h';
  Panel2.Caption:=S;
// - ve forme REAL cisla
  S:=''; R:=PrevodBytesReal(RBuff[0],RBuff[1],RBuff[2],RBuff[3]);
  S:=S+FloatToStr(R);
  Panel3.Caption:=S;
// - ve forme STRING retezce
  S:=''; for I:=0 to 3 do S:=S+chr(RBuff[I]);
  Panel4.Caption:=S;

// prijaty Status registr modulu StatusR (v hex tvaru)
  Label9.Caption:=IntToHex(StatusR,2)+'h';

// vyhodnoceni chyby komunikace s modulem MicroUnit - StatusP
  TPCI1052_Error(StatusP,@TextChyby);
  Label11.Caption:=IntToStr(StatusP)+' - '+BuffToStr(TextChyby);
end;
//______________________________________________________________________________ Tl. Opakuj Send
// Spusteni casovace periodickeho volani funkce TPCI1052_Send.

procedure TForm1.Button7Click(Sender: TObject);
begin
  if (Button7.Caption<>'Stop Send') then
    begin
      Button7.Caption:='Stop Send';
      Button1.Enabled:=false;
      Button2.Enabled:=false;
      Button3.Enabled:=false;
      Button4.Enabled:=false;
      Button5.Enabled:=false;
      Button6.Enabled:=false;
      Timer1.Enabled:=true;
    end
   else
    begin
      Button7.Caption:='Opakuj Send';
      Button1.Enabled:=true;
      Button2.Enabled:=false;
      Button3.Enabled:=true;
      Button4.Enabled:=true;
      Button5.Enabled:=true;
      Button6.Enabled:=true;
      Timer1.Enabled:=false;
    end;
end;
//______________________________________________________________________________ Tl. Konec
// Ukanceni programu.

procedure TForm1.Button8Click(Sender: TObject);
begin
  if Otevreno then TPCI1052_Done(@HNDL);
  Close;
end;
//______________________________________________________________________________ Casovac
// Obsluha casovace periodickeho volani fukce TPCI1052_Send.

procedure TForm1.Timer1Timer(Sender: TObject);
var
  S : string;
  I : integer;
  R : double;
begin
  try
    TBuff[0]:=StrToInt(Edit4.Text);      // adresa
    TBuff[1]:=StrToInt(Edit5.Text);      // funkce
    TBuff[2]:=StrToInt(Edit6.Text);      // periferie
    TBuff[3]:=StrToInt(Edit7.Text);      // prikaz
    TBuff[4]:=StrToInt(Edit8.Text);      // D1
    TBuff[5]:=StrToInt(Edit9.Text);      // D2
    TBuff[6]:=StrToInt(Edit10.Text);     // D3
    TBuff[7]:=StrToInt(Edit11.Text);     // D4
  except
    Label15.Caption:='Chybn zadn parametr';
    Exit;
  end;
  Chyba:=TPCI1052_Send(HNDL,@TBuff,@RBuff,@StatusR,@StatusP);
  TPCI1052_Error(Chyba,@TextChyby);
  Label15.Caption:=IntToStr(Chyba)+' - '+BuffToStr(TextChyby);
  S:=''; for I:=0 to 3 do S:=S+IntToStr(RBuff[I])+' ';
  Panel1.Caption:=S;
  S:=''; for I:=3 downto 0 do S:=S+IntToHex(RBuff[I],2); S:=S+'h';
  Panel2.Caption:=S;
  S:=''; R:=PrevodBytesReal(RBuff[0],RBuff[1],RBuff[2],RBuff[3]);
  S:=S+FloatToStr(R);
  Panel3.Caption:=S;
  S:=''; for I:=0 to 3 do S:=S+chr(RBuff[I]);
  Panel4.Caption:=S;
  Label9.Caption:=IntToHex(StatusR,2)+'h';
  TPCI1052_Error(StatusP,@TextChyby);
  Label11.Caption:=IntToStr(StatusP)+' - '+BuffToStr(TextChyby);
end;
//______________________________________________________________________________

end.
